'"fmod per pb.inc"
'FMOD VB6 Module
'
'FMOD_VERSION = 3.74 11-05-2004 Bervini Raf
'************
'* Enums
'************
' FMOD_ERRORS
' On failure of commands in FMOD, use FSOUND_GetError to attain what happened.
'
%FMOD_ERR_NONE  = 0            ' No errors
%FMOD_ERR_BUSY  = 1            ' Cannot call this command after FSOUND_Init.  Call FSOUND_Close first.
%FMOD_ERR_UNINITIALIZED  = 2   ' This command failed because FSOUND_Init was not called
%FMOD_ERR_INIT  = 3            ' Error initializing output device.
%FMOD_ERR_ALLOCATED  = 4       ' Error initializing output device, but more specifically, the output device is already in use and cannot be reused.
%FMOD_ERR_PLAY  = 5            ' Playing the sound failed.
%FMOD_ERR_OUTPUT_FORMAT  = 6   ' Soundcard does not support the features needed for this soundsystem (16bit stereo output)
%FMOD_ERR_COOPERATIVELEVEL  = 7' Error setting cooperative level for hardware.
%FMOD_ERR_CREATEBUFFER  = 8    ' Error creating hardware sound buffer.
%FMOD_ERR_FILE_NOTFOUND  = 9   ' File not found
%FMOD_ERR_FILE_FORMAT  = 10     ' Unknown file format
%FMOD_ERR_FILE_BAD  = 11        ' Error loading file
%FMOD_ERR_MEMORY  = 12          ' Not enough memory
%FMOD_ERR_VERSION  = 13         ' The version number of this file format is not supported
%FMOD_ERR_INVALID_PARAM  = 14   ' An invalid parameter was passed to this function
%FMOD_ERR_NO_EAX  = 15          ' Tried to use an EAX command on a non EAX enabled channel or output.
%FMOD_ERR_CHANNEL_ALLOC  = 16   ' Failed to allocate a new channel
%FMOD_ERR_RECORD  = 17          ' Recording is not supported on this machine
%FMOD_ERR_MEDIAPLAYER  = 18     ' Windows Media Player not installed so cannot play wma or use internet streaming.
%FMOD_ERR_CDDEVICE  = 19        ' An error occured trying to open the specified CD device
' FSOUND_OUTPUTTYPES
' These output types are used with FSOUND_SetOutput, to choose which output driver to use.
' FSOUND_OUTPUT_DSOUND will not support hardware 3d acceleration if the sound card driver
' does not support DirectX 6 Voice Manager Extensions.
' FSOUND_OUTPUT_WINMM is recommended for NT and CE.
'
%FSOUND_OUTPUT_NOSOUND  = 0  ' NoSound driver, all calls to this succeed but do nothing.
%FSOUND_OUTPUT_WINMM  = 1    ' Windows Multimedia driver.
%FSOUND_OUTPUT_DSOUND  = 2   ' DirectSound driver.  You need this to get EAX2 or EAX3 support, or FX api support.
%FSOUND_OUTPUT_A3D  = 3      ' A3D driver.
%FSOUND_OUTPUT_OSS  = 4      ' Linux/Unix OSS (Open Sound System) driver, i.e. the kernel sound drivers.
%FSOUND_OUTPUT_ESD  = 5      ' Linux/Unix ESD (Enlightment Sound Daemon) driver.
%FSOUND_OUTPUT_ALSA  = 6     ' Linux Alsa driver.
%FSOUND_OUTPUT_ASIO  = 7     ' Low latency ASIO driver
%FSOUND_OUTPUT_XBOX  = 8     ' Xbox driver
%FSOUND_OUTPUT_PS2  = 9      ' PlayStation 2 driver
%FSOUND_OUTPUT_MAC  = 10      ' Mac SoundMager driver
%FSOUND_OUTPUT_GC  = 11       ' Gamecube driver
%FSOUND_OUTPUT_NOSOUND_NONREALTIME  = 12 ' This is the same as nosound, but the sound generation is driven by FSOUND_Update
' FSOUND_MIXERTYPES
' These mixer types are used with FSOUND_SetMixer, to choose which mixer to use, or to act
' upon for other reasons using FSOUND_GetMixer.
' It is not nescessary to set the mixer.  FMOD will autodetect the best mixer for you.
'
%FSOUND_MIXER_AUTODETECT  = 0        ' CE/PS2 Only - Non interpolating/low quality mixer
%FSOUND_MIXER_BLENDMODE  = 1         ' removed / obsolete.
%FSOUND_MIXER_MMXP5  = 2             ' removed / obsolete.
%FSOUND_MIXER_MMXP6  = 3             ' removed / obsolete.
%FSOUND_MIXER_QUALITY_AUTODETECT  = 4' All platforms - Autodetect the fastest quality mixer based on your cpu.
%FSOUND_MIXER_QUALITY_FPU  = 5       ' Win32/Linux only - Interpolating/volume ramping FPU mixer.
%FSOUND_MIXER_QUALITY_MMXP5  = 6     ' Win32/Linux only - Interpolating/volume ramping FPU mixer.
%FSOUND_MIXER_QUALITY_MMXP6  = 7     ' Win32/Linux only - Interpolating/volume ramping ppro+ MMX mixer.
%FSOUND_MIXER_MONO  = 8              ' CE/PS2 only - MONO non interpolating/low quality mixer. For speed
%FSOUND_MIXER_QUALITY_MONO  = 9      ' CE/PS2 only - MONO Interpolating mixer.  For speed
' FMUSIC_TYPES
' These definitions describe the type of song being played.
' See FMUSIC_GetType
'
%FMUSIC_TYPE_NONE  = 0
%FMUSIC_TYPE_MOD  = 1        'Protracker / Fasttracker
%FMUSIC_TYPE_S3M  = 2        'ScreamTracker 3
%FMUSIC_TYPE_XM  = 3         'FastTracker 2
%FMUSIC_TYPE_IT  = 4         'Impulse Tracker.
%FMUSIC_TYPE_MIDI  = 5       'MIDI file
%FMUSIC_TYPE_FSB  = 6        'FMOD Sample Bank file
' FSOUND_DSP_PRIORITIES
' These default priorities are used by FMOD internal system DSP units.  They describe the
' position of the DSP chain, and the order of how audio processing is executed.
' You can actually through the use of FSOUND_DSP_GetxxxUnit (where xxx is the name of the DSP
' unit), disable or even change the priority of a DSP unit.
'
%FSOUND_DSP_DEFAULTPRIORITY_CLEARUNIT = 0           'DSP CLEAR unit - done first
%FSOUND_DSP_DEFAULTPRIORITY_SFXUNIT = 100           'DSP SFX unit - done second
%FSOUND_DSP_DEFAULTPRIORITY_MUSICUNIT = 200         'DSP MUSIC unit - done third
%FSOUND_DSP_DEFAULTPRIORITY_USER = 300              'User priority, use this as reference for your own dsp units
%FSOUND_DSP_DEFAULTPRIORITY_FFTUNIT = 900           'This reads data for FSOUND_DSP_GetSpectrum, so it comes after user units
%FSOUND_DSP_DEFAULTPRIORITY_CLIPANDCOPYUNIT = 1000  'DSP CLIP AND COPY unit - last
' FSOUND_CAPS
' Driver description bitfields.  Use FSOUND_Driver_GetCaps to determine if a driver enumerated
' has the settings you are after.  The enumerated driver depends on the output mode, see
' FSOUND_OUTPUTTYPES
'
%FSOUND_CAPS_HARDWARE = &H1       ' This driver supports hardware accelerated 3d sound.
%FSOUND_CAPS_EAX2 = &H2           ' This driver supports EAX 2 reverb
%FSOUND_CAPS_EAX3 = &H10          ' This driver supports EAX 3 reverb
' FSOUND_MODES
' Sample description bitfields, OR them together for loading and describing samples.
' NOTE.  If the file format being loaded already has a defined format, such as WAV or MP3, then
' trying to override the pre-defined format with a new set of format flags will not work.  For
' example, an 8 bit WAV file will not load as 16bit if you specify FSOUND_16BITS.  It will just
' ignore the flag and go ahead loading it as 8bits.  For these type of formats the only flags
' you can specify that will really alter the behaviour of how it is loaded, are the following.
'
' Looping behaviour - FSOUND_LOOP_OFF, FSOUND_LOOP_NORMAL, FSOUND_LOOP_BIDI
' Load destination - FSOUND_HW3D, FSOUND_HW2D, FSOUND_2D
' Loading behaviour - FSOUND_NONBLOCKING, FSOUND_LOADMEMORY, FSOUND_LOADRAW, FSOUND_MPEGACCURATE, FSOUND_MPEGHALFRATE, FSOUND_FORCEMONO
' Playback behaviour - FSOUND_STREAMABLE, FSOUND_ENABLEFX
' PlayStation 2 only - FSOUND_USECORE0, FSOUND_USECORE1, FSOUND_LOADMEMORYIOP
'
' See flag descriptions for what these do.
'
%FSOUND_LOOP_OFF = &H1             ' For non looping samples.
%FSOUND_LOOP_NORMAL = &H2          ' For forward looping samples.
%FSOUND_LOOP_BIDI = &H4            ' For bidirectional looping samples.  (no effect if in hardware).
%FSOUND_8BITS = &H8                ' For 8 bit samples.
%FSOUND_16BITS = &H10              ' For 16 bit samples.
%FSOUND_MONO = &H20                ' For mono samples.
%FSOUND_STEREO = &H40              ' For stereo samples.
%FSOUND_UNSIGNED = &H80            ' For source data containing unsigned samples.
%FSOUND_SIGNED = &H100             ' For source data containing signed data.
%FSOUND_DELTA = &H200              ' For source data stored as delta values.
%FSOUND_IT214 = &H400              ' For source data stored using IT214 compression.
%FSOUND_IT215 = &H800              ' For source data stored using IT215 compression.
%FSOUND_HW3D = &H1000              ' Attempts to make samples use 3d hardware acceleration. (if the card supports it)
%FSOUND_2D = &H2000                ' Ignores any 3d processing.  overrides FSOUND_HW3D.  Located in software.
%FSOUND_STREAMABLE = &H4000        ' For realtime streamable samples.  If you dont supply this sound may come out corrupted.
%FSOUND_LOADMEMORY = &H8000        ' For FSOUND_Sample_Load - name will be interpreted as a pointer to data
%FSOUND_LOADRAW = &H10000          ' For FSOUND_Sample_Load/FSOUND_Stream_Open - will ignore file format and treat as raw pcm.
%FSOUND_MPEGACCURATE = &H20000     ' For FSOUND_Stream_Open - scans MP2/MP3 (VBR also) for accurate FSOUND_Stream_GetLengthMs/FSOUND_Stream_SetTime.
%FSOUND_FORCEMONO = &H40000        ' For forcing stereo streams and samples to be mono - needed with FSOUND_HW3D - incurs speed hit
%FSOUND_HW2D = &H80000             ' 2d hardware sounds.  allows hardware specific effects
%FSOUND_ENABLEFX = &H100000        ' Allows DX8 FX to be played back on a sound.  Requires DirectX 8 - Note these sounds cant be played more than once, or have a changing frequency
%FSOUND_MPEGHALFRATE = &H200000    ' For FMODCE only - decodes mpeg streams using a lower quality decode, but faster execution
%FSOUND_XADPCM = &H400000          ' For XBOX only - Describes a user sample that its contents are compressed as XADPCM
%FSOUND_VAG = &H800000             ' For PS2 only - Describes a user sample that its contents are compressed as Sony VAG format.
%FSOUND_NONBLOCKING = &H1000000    ' For FSOUND_Stream_Open - Causes stream to open in the background and not block the foreground app - stream plays only when ready.
%FSOUND_GCADPCM = &H2000000        ' For Gamecube only - Contents are compressed as Gamecube DSP-ADPCM format
%FSOUND_MULTICHANNEL = &H4000000   ' For PS2 only - Contents are interleaved into a multi-channel (more than stereo) format
%FSOUND_USECORE0 = &H8000000       ' For PS2 only - Sample/Stream is forced to use hardware voices 00-23
%FSOUND_USECORE1 = &H10000000      ' For PS2 only - Sample/Stream is forced to use hardware voices 24-47
%FSOUND_LOADMEMORYIOP = &H20000000 ' For PS2 only - "name" will be interpreted as a pointer to data for streaming and samples.  The address provided will be an IOP address
%FSOUND_STREAM_NET = &H80000000    ' Specifies an internet stream
%FSOUND_NORMAL = %FSOUND_16BITS OR %FSOUND_SIGNED OR %FSOUND_MONO
' FSOUND_CDPLAYMODES
' Playback method for a CD Audio track, with FSOUND_CD_SetPlayMode
'
%FSOUND_CD_PLAYCONTINUOUS  = 0        'Starts from the current track and plays to end of CD.
%FSOUND_CD_PLAYONCE  = 1              'Plays the specified track then stops.
%FSOUND_CD_PLAYLOOPED  = 2            'Plays the specified track looped, forever until stopped manually.
%FSOUND_CD_PLAYRANDOM  = 3            'Plays tracks in random order
' FSOUND_CHANNELSAMPLEMODE
' Miscellaneous values for FMOD functions.
' FSOUND_PlaySound, FSOUND_PlaySoundEx, FSOUND_Sample_Alloc, FSOUND_Sample_Load, FSOUND_SetPan
'
%FSOUND_FREE = -1                 ' definition for dynamically allocated channel or sample
%FSOUND_UNMANAGED = -2            ' definition for allocating a sample that is NOT managed by fsound
%FSOUND_ALL = -3                  ' for a channel index or sample index, this flag affects ALL channels or samples available!  Not supported by all functions.
%FSOUND_STEREOPAN = -1            ' definition for full middle stereo volume on both channels
%FSOUND_SYSTEMCHANNEL = -1000     ' special channel ID for channel based functions that want to alter the global FSOUND software mixing output channel
%FSOUND_SYSTEMSAMPLE = -1000      ' special sample ID for all sample based functions that want to alter the global FSOUND software mixing output sample
' FSOUND_REVERB_PROPERTIES
' FSOUND_Reverb_SetProperties, FSOUND_Reverb_GetProperties, FSOUND_REVERB_PROPERTYFLAGS
'
TYPE FSOUND_REVERB_PROPERTIES
' MIN     MAX    DEFAULT DESCRIPTION
Environment         AS LONG     ' 0       25     0       sets all listener properties
EnvSize             AS SINGLE   ' 1.0     100.0  7.5     environment size in meters
EnvDiffusion        AS SINGLE   ' 0.0     1.0    1.0     environment diffusion
Room                AS LONG     ' -10000  0      -1000   room effect level (at mid frequencies)
RoomHF              AS LONG     ' -10000  0      -100    relative room effect level at high frequencies
RoomLF              AS LONG     ' -10000  0      0       relative room effect level at low frequencies
DecayTime           AS SINGLE   ' 0.1     20.0   1.49    reverberation decay time at mid frequencies
DecayHFRatio        AS SINGLE   ' 0.1     2.0    0.83    high-frequency to mid-frequency decay time ratio
DecayLFRatio        AS SINGLE   ' 0.1     2.0    1.0     low-frequency to mid-frequency decay time ratio
Reflections         AS LONG     ' -10000  1000   -2602   early reflections level relative to room effect
ReflectionsDelay    AS SINGLE   ' 0.0     0.3    0.007   initial reflection delay time
ReflectionsPan(3)   AS SINGLE   '                0,0,0   early reflections panning vector
Reverb              AS LONG     ' -1000   2000   200     late reverberation level relative to room effect
ReverbDelay         AS SINGLE   ' 0.0     0.1    0.011   late reverberation delay time relative to initial reflection
ReverbPan(3)        AS SINGLE   '                0,0,0   late reverberation panning vector
EchoTime            AS SINGLE   ' .075    0.25   0.25    echo time
EchoDepth           AS SINGLE   ' 0.0     1.0    0.0     echo depth
ModulationTime      AS SINGLE   ' 0.04    4.0    0.25    modulation time
ModulationDepth     AS SINGLE   ' 0.0     1.0    0.0     modulation depth
AirAbsorptionHF     AS SINGLE   ' -100    0.0    -5.0    change in level per meter at high frequencies
HFReference         AS SINGLE   ' 1000.0  20000  5000.0  reference high frequency (hz)
LFReference         AS SINGLE   ' 20.0    1000.0 250.0   reference low frequency (hz)
RoomRolloffFactor   AS SINGLE   ' 0.0     10.0   0.0     like FSOUND_3D_SetRolloffFactor but for room effect
Diffusion           AS SINGLE   ' 0.0     100.0  100.0   Value that controls the echo density in the late reverberation decay. (xbox only)
Density             AS SINGLE   ' 0.0     100.0  100.0   Value that controls the modal density in the late reverberation decay (xbox only)
flags               AS LONG     '                        modifies the behavior of above properties
END TYPE
' FSOUND_REVERB_FLAGS
' Values for the Flags member of the FSOUND_REVERB_PROPERTIES structure.
'
%FSOUND_REVERBFLAGS_DECAYTIMESCALE = &H1          ' EnvironmentSize affects reverberation decay time
%FSOUND_REVERBFLAGS_REFLECTIONSSCALE = &H2        ' EnvironmentSize affects reflection level
%FSOUND_REVERBFLAGS_REFLECTIONSDELAYSCALE = &H4   ' EnvironmentSize affects initial reflection delay time
%FSOUND_REVERBFLAGS_REVERBSCALE = &H8             ' EnvironmentSize affects reflections level
%FSOUND_REVERBFLAGS_REVERBDELAYSCALE = &H10       ' EnvironmentSize affects late reverberation delay time
%FSOUND_REVERBFLAGS_DECAYHFLIMIT = &H20           ' AirAbsorptionHF affects DecayHFRatio
%FSOUND_REVERBFLAGS_ECHOTIMESCALE = &H40          ' EnvironmentSize affects echo time
%FSOUND_REVERBFLAGS_MODULATIONTIMESCALE = &H80    ' EnvironmentSize affects modulation time
%FSOUND_REVERB_FLAGS_CORE0 = &H100                ' PS2 Only - Reverb is applied to CORE0 (hw voices 0-23)
%FSOUND_REVERB_FLAGS_CORE1 = &H200                ' PS2 Only - Reverb is applied to CORE1 (hw voices 24-47)
'*****
%FSOUND_REVERBFLAGS_DEFAULT = %FSOUND_REVERBFLAGS_DECAYTIMESCALE OR _
 %FSOUND_REVERBFLAGS_REFLECTIONSSCALE OR %FSOUND_REVERBFLAGS_REFLECTIONSDELAYSCALE OR _
 %FSOUND_REVERBFLAGS_REVERBSCALE OR %FSOUND_REVERBFLAGS_REVERBDELAYSCALE OR _
 %FSOUND_REVERBFLAGS_DECAYHFLIMIT OR %FSOUND_REVERB_FLAGS_CORE0 OR %FSOUND_REVERB_FLAGS_CORE1
' FSOUND_REVERB_CHANNELPROPERTIES
' Structure defining the properties for a reverb source, related to a FSOUND channel.
' FSOUND_Reverb_SetEnvironment, FSOUND_Reverb_SetEnvironmentAdvanced
'
TYPE FSOUND_REVERB_CHANNELPROPERTIES
Direct               AS LONG     ' direct path level (at low and mid frequencies)
DirectHF             AS LONG     ' relative direct path level at high frequencies
Room                 AS LONG     ' room effect level (at low and mid frequencies)
RoomHF               AS LONG     ' relative room effect level at high frequencies
Obstruction          AS LONG     ' main obstruction control (attenuation at high frequencies)
ObstructionLFRatio   AS SINGLE   ' obstruction low-frequency level re. main control
Occlusion            AS LONG     ' main occlusion control (attenuation at high frequencies)
OcclustionLFRatio    AS SINGLE   ' occlusion low-frequency level re. main control
OcclusionRoomRatio   AS SINGLE   ' relative occlusion control for room effect
OcclusionDirectRatio AS SINGLE   ' relative occlusion control for direct path
Exclusion            AS LONG     ' main exlusion control (attenuation at high frequencies)
ExclusionLFRatio     AS SINGLE   ' exclusion low-frequency level re. main control
OutsideVolumeHF      AS LONG     ' outside sound cone level at high frequencies
DopplerFactor        AS SINGLE   ' like DS3D flDopplerFactor but per source
RolloffFactor        AS SINGLE   ' like DS3D flRolloffFactor but per source
RoomRolloffFactor    AS SINGLE   ' like DS3D flRolloffFactor but for room effect
AirAbsorptionFactor  AS SINGLE   ' multiplies AirAbsorptionHF member of FSOUND_REVERB_PROPERTIES
flags                AS LONG     ' modifies the behavior of properties
END TYPE
' FSOUND_REVERB_CHANNELFLAGS
' Values for the Flags member of the FSOUND_REVERB_CHANNELPROPERTIES structure.
'
%FSOUND_REVERB_CHANNELFLAGS_DIRECTHFAUTO = &H1   ' Automatic setting of Direct due to distance from listener
%FSOUND_REVERB_CHANNELFLAGS_ROOMAUTO = &H2       ' Automatic setting of Room due to distance from listener
%FSOUND_REVERB_CHANNELFLAGS_ROOMHFAUTO = &H4     ' Automatic setting of RoomHF due to distance from listener
'*****
%FSOUND_REVERB_CHANNELFLAGS_DEFAULT = %FSOUND_REVERB_CHANNELFLAGS_DIRECTHFAUTO OR _
  %FSOUND_REVERB_CHANNELFLAGS_ROOMAUTO OR %FSOUND_REVERB_CHANNELFLAGS_ROOMHFAUTO
' FSOUND_FX_MODES
' These values are used with FSOUND_FX_Enable to enable DirectX 8 FX for a channel.
'
%FSOUND_FX_CHORUS  = 0
%FSOUND_FX_COMPRESSOR  = 1
%FSOUND_FX_DISTORTION  = 2
%FSOUND_FX_ECHO  = 3
%FSOUND_FX_FLANGER  = 4
%FSOUND_FX_GARGLE  = 5
%FSOUND_FX_I3DL2REVERB  = 6
%FSOUND_FX_PARAMEQ  = 7
%FSOUND_FX_WAVES_REVERB  = 8
'FSOUND_SPEAKERMODES
'These are speaker types defined for use with the FSOUND_SetSpeakerMode command.
'Note - Only reliably works with FSOUND_OUTPUT_DSOUND or FSOUND_OUTPUT_XBOX output modes.  Other output modes will only
'interpret FSOUND_SPEAKERMODE_MONO and set everything else to be stereo.
'Using either DolbyDigital or DTS will use whatever 5.1 digital mode is available if destination hardware is unsure.
'
%FSOUND_SPEAKERMODE_DOLBYDIGITAL  = 0 ' The audio is played through a speaker arrangement of surround speakers with a subwoofer.
%FSOUND_SPEAKERMODE_HEADPHONE  = 1    ' The speakers are headphones.
%FSOUND_SPEAKERMODE_MONO  = 2         ' The speakers are monaural.
%FSOUND_SPEAKERMODE_QUAD  = 3         ' The speakers are quadraphonic.
%FSOUND_SPEAKERMODE_STEREO  = 4       ' The speakers are stereo (default value).
%FSOUND_SPEAKERMODE_SURROUND  = 5     ' The speakers are surround sound.
%FSOUND_SPEAKERMODE_DTS  = 6          ' The audio is played through a speaker arrangement of surround speakers with a subwoofer.
%FSOUND_SPEAKERMODE_PROLOGIC2  = 7    ' Dolby Prologic 2.  Playstation 2 and Gamecube only
' FSOUND_INIT_FLAGS
' Initialization flags.  Use them with FSOUND_Init in the flags parameter to change various behaviour.
' FSOUND_INIT_ENABLESYSTEMCHANNELFX Is an init mode which enables the FSOUND mixer buffer to be affected by DirectX 8 effects.
' Note that due to limitations of DirectSound, FSOUND_Init may fail if this is enabled because the buffersize is too small.
' This can be fixed with FSOUND_SetBufferSize.  Increase the BufferSize until it works.
' When it is enabled you can use the FSOUND_FX api, and use FSOUND_SYSTEMCHANNEL as the channel id when setting parameters.
'
%FSOUND_INIT_USEDEFAULTMIDISYNTH = &H1       'Causes MIDI playback to force software decoding.
%FSOUND_INIT_GLOBALFOCUS = &H2               'For DirectSound output - sound is not muted when window is out of focus.
%FSOUND_INIT_ENABLESYSTEMCHANNELFX = &H4     'For DirectSound output - Allows FSOUND_FX api to be used on global software mixer output!
%FSOUND_INIT_ACCURATEVULEVELS = &H8          'This latency adjusts FSOUND_GetCurrentLevels, but incurs a small cpu and memory hit
%FSOUND_INIT_PS2_DISABLECORE0REVERB = &H10   'PS2 only - Disable reverb on CORE 0 to regain SRAM
%FSOUND_INIT_PS2_DISABLECORE1REVERB = &H20   'PS2 only - Disable reverb on CORE 1 to regain SRAM
%FSOUND_INIT_PS2_SWAPDMACORES = &H40         'PS2 only - By default FMOD uses DMA CH0 for mixing, CH1 for uploads, this flag swaps them around
%FSOUND_INIT_DONTLATENCYADJUST = &H80        'Callbacks are not latency adjusted, and are called at mix time.  Also information functions are immediate
%FSOUND_INIT_GC_INITLIBS = &H100             'Gamecube only - Initializes GC audio libraries
%FSOUND_INIT_STREAM_FROM_MAIN_THREAD = &H200 'Turns off fmod streamer thread, and makes streaming update from FSOUND_Update called by the user
' FSOUND_STREAM_NET_STATUS
' Status values for internet streams. Use FSOUND_Stream_Net_GetStatus to get the current status of an internet stream.
'
%FSOUND_STREAM_NET_NOTCONNECTED  = 0        ' Stream hasn't connected yet
%FSOUND_STREAM_NET_CONNECTING  = 1          ' Stream is connecting to remote host
%FSOUND_STREAM_NET_BUFFERING  = 2           ' Stream is buffering data
%FSOUND_STREAM_NET_READY  = 3               ' Stream is ready to play
%FSOUND_STREAM_NET_ERROR  = 4               ' Stream has suffered a fatal error
' FSOUND_TAGFIELD_TYPE
' Describes the type of a particular tag field.
' See FSOUND_Stream_GetNumTagFields, FSOUND_Stream_GetTagField, FSOUND_Stream_FindTagField
'
%FSOUND_TAGFIELD_VORBISCOMMENT = 0     ' A vorbis comment
%FSOUND_TAGFIELD_ID3V1  = 0                ' Part of an ID3v1 tag
%FSOUND_TAGFIELD_ID3V2  = 1                ' An ID3v2 frame
%FSOUND_TAGFIELD_SHOUTCAST  = 2            ' A SHOUTcast header line
%FSOUND_TAGFIELD_ICECAST  = 3              ' An Icecast header line
%FSOUND_TAGFIELD_ASF  = 4                  ' An Advanced Streaming Format header line
' FSOUND_STATUS_FLAGS
' These values describe the protocol and format of an internet stream. Use FSOUND_Stream_Net_GetStatus to retrieve this information for an open internet stream.
'
%FSOUND_PROTOCOL_SHOUTCAST = &H1
%FSOUND_PROTOCOL_ICECAST = &H2
%FSOUND_PROTOCOL_HTTP = &H4
%FSOUND_FORMAT_MPEG = &H10000
%FSOUND_FORMAT_OGGVORBIS = &H20000
' FSOUND_TOC_TAG
' FSOUND_Stream_Open, FSOUND_Stream_FindTagField
'
TYPE FSOUND_TOC_TAG
'****
 dummy AS STRING*1
'**** TagName(3)      AS BYTE         ' The string "TOC" (4th character is 0), just in case this structure is accidentally treated as a string.
'**** NumTracks       AS LONG         ' The number of tracks on the CD.
'**** MIN(99)         AS LONG         ' The start offset of each track in minutes.
'**** Sec(99)         AS LONG         ' The start offset of each track in seconds.
'**** FRAME(99)       AS LONG         ' The start offset of each track in frames.
END TYPE
'/* ================================== */
'/* Initialization / Global functions. */
'/* ================================== */
' PRE - FSOUND_Init functions. These cant be called after FSOUND_Init is
' called (they will fail). They set up FMOD system functionality.
'****DECLARE FUNCTION FSOUND_SetOutput LIB "fmod.dll" ALIAS "_FSOUND_SetOutput@4" (BYVAL outputtype AS FSOUND_OUTPUTTYPES) AS BYTE
DECLARE FUNCTION FSOUND_SetOutput LIB "fmod.dll" ALIAS "_FSOUND_SetOutput@4" (BYVAL outputtype AS BYTE) AS BYTE
DECLARE FUNCTION FSOUND_SetDriver LIB "fmod.dll" ALIAS "_FSOUND_SetDriver@4" (BYVAL driver AS LONG) AS BYTE
'****DECLARE FUNCTION FSOUND_SetMixer LIB "fmod.dll" ALIAS "_FSOUND_SetMixer@4" (BYVAL mixer AS FSOUND_MIXERTYPES) AS BYTE
DECLARE FUNCTION FSOUND_SetMixer LIB "fmod.dll" ALIAS "_FSOUND_SetMixer@4" (BYVAL mixer AS BYTE) AS BYTE
DECLARE FUNCTION FSOUND_SetBufferSize LIB "fmod.dll" ALIAS "_FSOUND_SetBufferSize@4" (BYVAL lenms AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_SetHWND LIB "fmod.dll" ALIAS "_FSOUND_SetHWND@4" (BYVAL hwnd AS LONG) AS BYTE
 DECLARE FUNCTION FSOUND_SetMinHardwareChannels LIB "fmod.dll" ALIAS "_FSOUND_SetMinHardwareChannels@4" (BYVAL min_pb AS INTEGER) AS BYTE
 DECLARE FUNCTION FSOUND_SetMaxHardwareChannels LIB "fmod.dll" ALIAS "_FSOUND_SetMaxHardwareChannels@4" (BYVAL max_pb AS INTEGER) AS BYTE
DECLARE FUNCTION FSOUND_SetMemorySystem LIB "fmod.dll" ALIAS "_FSOUND_SetMemorySystem@20" (BYVAL pool AS LONG, BYVAL poollen AS LONG, BYVAL useralloc AS LONG, BYVAL userrealloc AS LONG, BYVAL userfree AS LONG) AS BYTE
'
'   Main initialization / closedown functions.
'   Note : Use FSOUND_INIT_USEDEFAULTMIDISYNTH with FSOUND_Init for software override
'          with MIDI playback.
'        : Use FSOUND_INIT_GLOBALFOCUS with FSOUND_Init to make sound audible no matter
'          which window is in focus. (FSOUND_OUTPUT_DSOUND only)
'
'****DECLARE FUNCTION FSOUND_Init LIB "fmod.dll" ALIAS "_FSOUND_Init@12" (BYVAL mixrate AS LONG, BYVAL maxchannels AS LONG, BYVAL flags AS FSOUND_INITMODES) AS BYTE
DECLARE FUNCTION FSOUND_Init LIB "fmod.dll" ALIAS "_FSOUND_Init@12" (BYVAL mixrate AS LONG, BYVAL maxchannels AS LONG, BYVAL flags AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Close LIB "fmod.dll" ALIAS "_FSOUND_Close@0" () AS LONG
'
'   Runtime system level functions
'
DECLARE FUNCTION FSOUND_Update LIB "fmod.dll" ALIAS "_FSOUND_Update@0" () AS LONG
'****DECLARE FUNCTION FSOUND_SetSpeakerMode LIB "fmod.dll" ALIAS "_FSOUND_SetSpeakerMode@4" (BYVAL speakermode AS FSOUND_SPEAKERMODES) AS LONG
DECLARE FUNCTION FSOUND_SetSpeakerMode LIB "fmod.dll" ALIAS "_FSOUND_SetSpeakerMode@4" (BYVAL speakermode AS LONG) AS LONG
DECLARE FUNCTION FSOUND_SetSFXMasterVolume LIB "fmod.dll" ALIAS "_FSOUND_SetSFXMasterVolume@4" (BYVAL volume AS LONG) AS LONG
DECLARE FUNCTION FSOUND_SetPanSeperation LIB "fmod.dll" ALIAS "_FSOUND_SetPanSeperation@4" (BYVAL pansep AS SINGLE) AS LONG
DECLARE FUNCTION FSOUND_File_SetCallbacks LIB "fmod.dll" ALIAS "_FSOUND_File_SetCallbacks@20"_
 (BYVAL OpenCallback AS LONG, BYVAL CloseCallback AS LONG, BYVAL ReadCallback AS LONG, BYVAL SeekCallback AS LONG, BYVAL TellCallback AS LONG) AS LONG
'
' System information functions.
'
DECLARE FUNCTION FSOUND_GetError LIB "fmod.dll" ALIAS "_FSOUND_GetError@0" () AS LONG'FMOD_ERRORS
DECLARE FUNCTION FSOUND_GetVersion LIB "fmod.dll" ALIAS "_FSOUND_GetVersion@0" () AS SINGLE
DECLARE FUNCTION FSOUND_GetOutput LIB "fmod.dll" ALIAS "_FSOUND_GetOutput@0" () AS LONG'FSOUND_OUTPUTTYPES
DECLARE FUNCTION FSOUND_GetOutputHandle LIB "fmod.dll" ALIAS "_FSOUND_GetOutputHandle@0" () AS LONG
DECLARE FUNCTION FSOUND_GetDriver LIB "fmod.dll" ALIAS "_FSOUND_GetDriver@0" () AS LONG
DECLARE FUNCTION FSOUND_GetMixer LIB "fmod.dll" ALIAS "_FSOUND_GetMixer@0" () AS LONG'FSOUND_MIXERTYPES
DECLARE FUNCTION FSOUND_GetNumDrivers LIB "fmod.dll" ALIAS "_FSOUND_GetNumDrivers@0" () AS LONG
DECLARE FUNCTION FSOUND_GetDriverName LIB "fmod.dll" ALIAS "_FSOUND_GetDriverName@4" (BYVAL id AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetDriverCaps LIB "fmod.dll" ALIAS "_FSOUND_GetDriverCaps@8" (BYVAL id AS LONG, BYREF caps AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_GetOutputRate LIB "fmod.dll" ALIAS "_FSOUND_GetOutputRate@0" () AS LONG
DECLARE FUNCTION FSOUND_GetMaxChannels LIB "fmod.dll" ALIAS "_FSOUND_GetMaxChannels@0" () AS LONG
DECLARE FUNCTION FSOUND_GetMaxSamples LIB "fmod.dll" ALIAS "_FSOUND_GetMaxSamples@0" () AS LONG
DECLARE FUNCTION FSOUND_GetSFXMasterVolume LIB "fmod.dll" ALIAS "_FSOUND_GetSFXMasterVolume@0" () AS LONG
'****DECLARE FUNCTION FSOUND_GetNumHWChannels LIB "fmod.dll" ALIAS "_FSOUND_GetNumHWChannels@12" (BYREF num2d AS LONG, BYREF num3d AS LONG, BYREF total AS LONG)
DECLARE FUNCTION FSOUND_GetNumHWChannels LIB "fmod.dll" ALIAS "_FSOUND_GetNumHWChannels@12" (BYREF num2d AS LONG, BYREF num3d AS LONG, BYREF total AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetChannelsPlaying LIB "fmod.dll" ALIAS "_FSOUND_GetChannelsPlaying@0" () AS LONG
DECLARE FUNCTION FSOUND_GetCPUUsage LIB "fmod.dll" ALIAS "_FSOUND_GetCPUUsage@0" () AS SINGLE
DECLARE SUB FSOUND_GetMemoryStats LIB "fmod.dll" ALIAS "_FSOUND_GetMemoryStats@8" (BYREF currentalloced AS LONG, BYREF maxalloced AS LONG)
'/* =================================== */
'/* Sample management / load functions. */
'/* =================================== */
'   Sample creation and management functions
'   Note : Use FSOUND_LOADMEMORY   flag with FSOUND_Sample_Load to load from memory.
'          Use FSOUND_LOADRAW      flag with FSOUND_Sample_Load to treat as as raw pcm data.
'****DECLARE FUNCTION FSOUND_Sample_Load LIB "fmod.dll" ALIAS "_FSOUND_Sample_Load@20" (BYVAL index AS LONG, BYVAL NAME AS STRING, BYVAL mode AS FSOUND_MODES, BYVAL offset AS LONG, BYVAL length AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Sample_Load LIB "fmod.dll" ALIAS "_FSOUND_Sample_Load@20" (BYVAL index AS LONG, BYVAL NAMEi AS STRING, BYVAL mode AS LONG, BYVAL offset AS LONG, BYVAL length AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Sample_Alloc LIB "fmod.dll" ALIAS "_FSOUND_Sample_Alloc@28"_
 (BYVAL index AS LONG, BYVAL length AS LONG, BYVAL mode AS LONG, BYVAL deffreq AS LONG, BYVAL defvol AS LONG, BYVAL defpan AS LONG, BYVAL defpri AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Sample_Free LIB "fmod.dll" ALIAS "_FSOUND_Sample_Free@4" (BYVAL sptr AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Sample_Upload LIB "fmod.dll" ALIAS "_FSOUND_Sample_Upload@12" (BYVAL sptr AS LONG, BYREF srcdata AS LONG, BYVAL mode AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Sample_Lock LIB "fmod.dll" ALIAS "_FSOUND_Sample_Lock@28" (BYVAL sptr AS LONG, BYVAL offset AS LONG, BYVAL length AS LONG, BYREF ptr1 AS LONG, BYREF ptr2 AS LONG, BYREF len1 AS LONG, BYREF len2 AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Sample_Unlock LIB "fmod.dll" ALIAS "_FSOUND_Sample_Unlock@20" (BYVAL sptr AS LONG, BYVAL sptr1 AS LONG, BYVAL sptr2 AS LONG, BYVAL len1 AS LONG, BYVAL len2 AS LONG) AS BYTE
'   Sample control functions
'****DECLARE FUNCTION FSOUND_Sample_SetMode LIB "fmod.dll" ALIAS "_FSOUND_Sample_SetMode@8" (BYVAL sptr AS LONG, BYVAL mode AS FSOUND_MODES) AS BYTE
DECLARE FUNCTION FSOUND_Sample_SetMode LIB "fmod.dll" ALIAS "_FSOUND_Sample_SetMode@8" (BYVAL sptr AS LONG, BYVAL mode AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Sample_SetLoopPoints LIB "fmod.dll" ALIAS "_FSOUND_Sample_SetLoopPoints@12" (BYVAL sptr AS LONG, BYVAL loopstart AS LONG, BYVAL loopend AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Sample_SetDefaults LIB "fmod.dll" ALIAS "_FSOUND_Sample_SetDefaults@20" (BYVAL sptr AS LONG, BYVAL deffreq AS LONG, BYVAL defvol AS LONG, BYVAL defpan AS LONG, BYVAL defpri AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Sample_SetDefaultsEx LIB "fmod.dll" ALIAS "_FSOUND_Sample_SetDefaultsEx@32"_
 (BYVAL sptr AS LONG, BYVAL deffreq AS LONG, BYVAL defvol AS LONG, BYVAL defpan AS LONG, BYVAL defpri AS LONG, BYVAL varfreq AS LONG, BYVAL varvol AS LONG,BYVAL varpan AS LONG) AS BYTE
 DECLARE FUNCTION FSOUND_Sample_SetMinMaxDistance LIB "fmod.dll" ALIAS "_FSOUND_Sample_SetMinMaxDistance@12" (BYVAL sptr AS LONG, BYVAL min_pb AS SINGLE, BYVAL max_pb AS SINGLE) AS BYTE
 DECLARE FUNCTION FSOUND_Sample_SetMaxPlaybacks LIB "fmod.dll" ALIAS "_FSOUND_Sample_SetMaxPlaybacks@8" (BYVAL sptr AS LONG, BYVAL max_pb AS LONG) AS BYTE
'   Sample information functions
DECLARE FUNCTION FSOUND_Sample_Get LIB "fmod.dll" ALIAS "_FSOUND_Sample_Get@4" (BYVAL sampno AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Sample_GetName LIB "fmod.dll" ALIAS "_FSOUND_Sample_GetName@4" (BYVAL sptr AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Sample_GetLength LIB "fmod.dll" ALIAS "_FSOUND_Sample_GetLength@4" (BYVAL sptr AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Sample_GetLoopPoints LIB "fmod.dll" ALIAS "_FSOUND_Sample_GetLoopPoints@12" (BYVAL sptr AS LONG, BYREF loopstart AS LONG, BYREF loopend AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Sample_GetDefaults LIB "fmod.dll" ALIAS "_FSOUND_Sample_GetDefaults@20" (BYVAL sptr AS LONG, BYREF deffreq AS LONG, BYREF defvol AS LONG, BYREF defpan AS LONG, BYREF defpri AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Sample_GetDefaultsEx LIB "fmod.dll" ALIAS "_FSOUND_Sample_GetDefaultsEx@32"_
 (BYVAL sptr AS LONG, BYREF deffreq AS LONG, BYREF defvol AS LONG, BYREF defpan AS LONG, BYREF defpri AS LONG, BYREF varfreq AS LONG, BYREF varvol AS LONG,BYREF varpan AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Sample_GetMode LIB "fmod.dll" ALIAS "_FSOUND_Sample_GetMode@4" (BYVAL sptr AS LONG) AS LONG
 DECLARE FUNCTION FSOUND_Sample_GetMinMaxDistance LIB "fmod.dll" ALIAS "_FSOUND_Sample_GetMinMaxDistance@12" (BYVAL sptr AS LONG, BYREF min_pb AS SINGLE, BYREF max_pb AS SINGLE) AS BYTE
'/* ============================ */
'/* Channel control functions.   */
'/* ============================ */
'   Playing and stopping sounds.
'   Note : Use FSOUND_FREE as the channel variable, to let FMOD pick a free channel for you.
'          Use FSOUND_ALL as the channel variable to control ALL channels with one function call!
DECLARE FUNCTION FSOUND_PlaySound LIB "fmod.dll" ALIAS "_FSOUND_PlaySound@8" (BYVAL channel AS LONG, BYVAL sptr AS LONG) AS LONG
DECLARE FUNCTION FSOUND_PlaySoundEx LIB "fmod.dll" ALIAS "_FSOUND_PlaySoundEx@16" (BYVAL channel AS LONG, BYVAL sptr AS LONG, BYVAL dsp AS LONG, BYVAL startpaused AS BYTE) AS LONG
DECLARE FUNCTION FSOUND_StopSound LIB "fmod.dll" ALIAS "_FSOUND_StopSound@4" (BYVAL channel AS LONG) AS BYTE
'   Functions to control playback of a channel.
'   Note : FSOUND_ALL can be used on most of these functions as a channel value.
DECLARE FUNCTION FSOUND_SetFrequency LIB "fmod.dll" ALIAS "_FSOUND_SetFrequency@8" (BYVAL channel AS LONG, BYVAL freq AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_SetVolume LIB "fmod.dll" ALIAS "_FSOUND_SetVolume@8" (BYVAL channel AS LONG, BYVAL Vol AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_SetVolumeAbsolute LIB "fmod.dll" ALIAS "_FSOUND_SetVolumeAbsolute@8" (BYVAL channel AS LONG, BYVAL Vol AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_SetPan LIB "fmod.dll" ALIAS "_FSOUND_SetPan@8" (BYVAL channel AS LONG, BYVAL pan AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_SetSurround LIB "fmod.dll" ALIAS "_FSOUND_SetSurround@8" (BYVAL channel AS LONG, BYVAL surround AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_SetMute LIB "fmod.dll" ALIAS "_FSOUND_SetMute@8" (BYVAL channel AS LONG, BYVAL mute AS BYTE) AS BYTE
DECLARE FUNCTION FSOUND_SetPriority LIB "fmod.dll" ALIAS "_FSOUND_SetPriority@8" (BYVAL channel AS LONG, BYVAL Priority AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_SetReserved LIB "fmod.dll" ALIAS "_FSOUND_SetReserved@8" (BYVAL channel AS LONG, BYVAL reserved AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_SetPaused LIB "fmod.dll" ALIAS "_FSOUND_SetPaused@8" (BYVAL channel AS LONG, BYVAL Paused AS BYTE) AS BYTE
DECLARE FUNCTION FSOUND_SetLoopMode LIB "fmod.dll" ALIAS "_FSOUND_SetLoopMode@8" (BYVAL channel AS LONG, BYVAL loopmode AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_SetCurrentPosition LIB "fmod.dll" ALIAS "_FSOUND_SetCurrentPosition@8" (BYVAL channel AS LONG, BYVAL offset AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_3D_SetAttributes LIB "fmod.dll" ALIAS "_FSOUND_3D_SetAttributes@12" (BYVAL channel AS LONG, BYREF Pos AS SINGLE, BYREF vel AS SINGLE) AS BYTE
 DECLARE FUNCTION FSOUND_3D_SetMinMaxDistance LIB "fmod.dll" ALIAS "_FSOUND_3D_SetMinMaxDistance@12" (BYVAL channel AS LONG, BYVAL min_pb AS SINGLE, BYVAL max_pb AS SINGLE) AS BYTE
'
'   Channel information functions.
'
DECLARE FUNCTION FSOUND_IsPlaying LIB "fmod.dll" ALIAS "_FSOUND_IsPlaying@4" (BYVAL channel AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_GetFrequency LIB "fmod.dll" ALIAS "_FSOUND_GetFrequency@4" (BYVAL channel AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetVolume LIB "fmod.dll" ALIAS "_FSOUND_GetVolume@4" (BYVAL channel AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetAmplitude LIB "fmod.dll" ALIAS "_FSOUND_GetAmplitude@4" (BYVAL channel AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetPan LIB "fmod.dll" ALIAS "_FSOUND_GetPan@4" (BYVAL channel AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetSurround LIB "fmod.dll" ALIAS "_FSOUND_GetSurround@4" (BYVAL channel AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_GetMute LIB "fmod.dll" ALIAS "_FSOUND_GetMute@4" (BYVAL channel AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_GetPriority LIB "fmod.dll" ALIAS "_FSOUND_GetPriority@4" (BYVAL channel AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetReserved LIB "fmod.dll" ALIAS "_FSOUND_GetReserved@4" (BYVAL channel AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_GetPaused LIB "fmod.dll" ALIAS "_FSOUND_GetPaused@4" (BYVAL channel AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_GetLoopMode LIB "fmod.dll" ALIAS "_FSOUND_GetLoopMode@4" (BYVAL channel AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetCurrentPosition LIB "fmod.dll" ALIAS "_FSOUND_GetCurrentPosition@4" (BYVAL channel AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetCurrentSample LIB "fmod.dll" ALIAS "_FSOUND_GetCurrentSample@4" (BYVAL channel AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetCurrentLevels LIB "fmod.dll" ALIAS "_FSOUND_GetCurrentLevels@12" (BYVAL channel AS LONG, BYREF l AS SINGLE, BYREF r AS SINGLE) AS BYTE
DECLARE FUNCTION FSOUND_GetNumSubChannels LIB "fmod.dll" ALIAS "_FSOUND_GetNumSubChannels@4" (BYVAL channel AS LONG) AS LONG
DECLARE FUNCTION FSOUND_GetSubChannel LIB "fmod.dll" ALIAS "_FSOUND_GetSubChannel@8" (BYVAL channel AS LONG, BYVAL subchannel AS LONG) AS LONG
DECLARE FUNCTION FSOUND_3D_GetAttributes LIB "fmod.dll" ALIAS "_FSOUND_3D_GetAttributes@12" (BYVAL channel AS LONG, BYREF Pos AS SINGLE, BYREF vel AS SINGLE) AS BYTE
 DECLARE FUNCTION FSOUND_3D_GetMinMaxDistance LIB "fmod.dll" ALIAS "_FSOUND_3D_GetMinMaxDistance@12" (BYVAL channel AS LONG, BYREF min_pb AS SINGLE, BYREF max_pb AS SINGLE) AS BYTE

'/* ========================== */
'/* Global 3D sound functions. */
'/* ========================== */
'    See also 3d sample and channel based functions above.
'    Call FSOUND_Update once a frame to process 3d information.
DECLARE FUNCTION FSOUND_3D_Listener_SetCurrent LIB "fmod.dll" ALIAS "_FSOUND_3D_Listener_SetCurrent@8" (BYVAL current AS LONG) AS LONG
DECLARE FUNCTION FSOUND_3D_Listener_SetAttributes LIB "fmod.dll" ALIAS "_FSOUND_3D_Listener_SetAttributes@32"_
 (BYVAL Pos AS SINGLE, BYVAL vel AS SINGLE, BYVAL fx AS SINGLE, BYVAL fy AS SINGLE, BYVAL fz AS SINGLE, BYVAL tx AS SINGLE, BYVAL ty AS SINGLE,BYVAL tz AS SINGLE) AS LONG
DECLARE FUNCTION FSOUND_3D_Listener_GetAttributes LIB "fmod.dll" ALIAS "_FSOUND_3D_Listener_GetAttributes@32"_
 (BYREF Pos AS SINGLE, BYREF vel AS SINGLE, BYREF fx AS SINGLE, BYREF fy AS SINGLE, BYREF fz AS SINGLE, BYREF tx AS SINGLE, BYREF ty AS SINGLE,BYREF tz AS SINGLE) AS LONG
DECLARE FUNCTION FSOUND_3D_SetDopplerFactor LIB "fmod.dll" ALIAS "_FSOUND_3D_SetDopplerFactor@4" (BYVAL fscale AS SINGLE) AS LONG
DECLARE FUNCTION FSOUND_3D_SetDistanceFactor LIB "fmod.dll" ALIAS "_FSOUND_3D_SetDistanceFactor@4" (BYVAL fscale AS SINGLE) AS LONG
DECLARE FUNCTION FSOUND_3D_SetRolloffFactor LIB "fmod.dll" ALIAS "_FSOUND_3D_SetRolloffFactor@4" (BYVAL fscale AS SINGLE) AS LONG
'/* =================== */
'/* FX functions.       */
'/* =================== */
'   Functions to control DX8 only effects processing.
'
'   - FX enabled samples can only be played once at a time, not multiple times at once.
'   - Sounds have to be created with FSOUND_HW2D or FSOUND_HW3D for this to work.
'   - FSOUND_INIT_ENABLESYSTEMCHANNELFX can be used to apply hardware effect processing to the
'     global mixed output of FMOD's software channels.
'   - FSOUND_FX_Enable returns an FX handle that you can use to alter fx parameters.
'   - FSOUND_FX_Enable can be called multiple times in a row, even on the same FX type,
'     it will return a unique handle for each FX.
'   - FSOUND_FX_Enable cannot be called if the sound is playing or locked.
'   - FSOUND_FX_Disable must be called to reset/clear the FX from a channel.
'****DECLARE FUNCTION FSOUND_FX_Enable LIB "fmod.dll" ALIAS "_FSOUND_FX_Enable@8" (BYVAL channel AS LONG, BYVAL fx AS FSOUND_FX_MODES) AS LONG
DECLARE FUNCTION FSOUND_FX_Enable LIB "fmod.dll" ALIAS "_FSOUND_FX_Enable@8" (BYVAL channel AS LONG, BYVAL fx AS LONG) AS LONG
DECLARE FUNCTION FSOUND_FX_Disable LIB "fmod.dll" ALIAS "_FSOUND_FX_Disable@4" (BYVAL channel AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_FX_SetChorus LIB "fmod.dll" ALIAS "_FSOUND_FX_SetChorus@32"_
 (BYVAL fxid AS LONG, BYVAL WetDryMix AS SINGLE, BYVAL Depth AS SINGLE, BYVAL Feedback AS SINGLE, BYVAL Frequency AS SINGLE, BYVAL Waveform AS LONG, BYVAL Delay AS SINGLE,BYVAL Phase AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_FX_SetCompressor LIB "fmod.dll" ALIAS "_FSOUND_FX_SetCompressor@28"_
 (BYVAL fxid AS LONG, BYVAL Gain AS SINGLE, BYVAL Attack AS SINGLE, BYVAL Release AS SINGLE, BYVAL Threshold AS SINGLE, BYVAL Ratio AS SINGLE, BYVAL Predelay AS SINGLE) AS BYTE
DECLARE FUNCTION FSOUND_FX_SetDistortion LIB "fmod.dll" ALIAS "_FSOUND_FX_SetDistortion@24"_
 (BYVAL fxid AS LONG, BYVAL Gain AS SINGLE, BYVAL Edge AS SINGLE, BYVAL PostEQCenterFrequency AS SINGLE, BYVAL PostEQBandwidth AS SINGLE, BYVAL PreLowpassCutoff AS SINGLE) AS BYTE
DECLARE FUNCTION FSOUND_FX_SetEcho LIB "fmod.dll" ALIAS "_FSOUND_FX_SetEcho@24" (BYVAL fxid AS LONG, BYVAL WetDryMix AS SINGLE, BYVAL Feedback AS SINGLE, BYVAL LeftDelay AS SINGLE, BYVAL RightDelay AS SINGLE, BYVAL PanDelay AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_FX_SetFlanger LIB "fmod.dll" ALIAS "_FSOUND_FX_SetFlanger@32"_
 (BYVAL fxid AS LONG, BYVAL WetDryMix AS SINGLE, BYVAL Depth AS SINGLE, BYVAL Feedback AS SINGLE, BYVAL Frequency AS SINGLE, BYVAL Waveform AS LONG, BYVAL Delay AS SINGLE, BYVAL Phase AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_FX_SetGargle LIB "fmod.dll" ALIAS "_FSOUND_FX_SetGargle@12" (BYVAL fxid AS LONG, BYVAL RateHz AS LONG, BYVAL WaveShape AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_FX_SetI3DL2Reverb LIB "fmod.dll" ALIAS "_FSOUND_FX_SetI3DL2Reverb@52"_
 (BYVAL fxid AS LONG, BYVAL Room AS LONG, BYVAL RoomHF AS LONG, BYVAL RoomRolloffFactor AS SINGLE, BYVAL DecayTime AS SINGLE, BYVAL DecayHFRatio AS SINGLE,_
  BYVAL Reflections AS LONG, BYVAL ReflectionsDelay AS SINGLE, BYVAL Reverb AS LONG, BYVAL ReverbDelay AS SINGLE, BYVAL Diffusion AS SINGLE, BYVAL Density AS SINGLE, BYVAL HFReference AS SINGLE) AS BYTE
DECLARE FUNCTION FSOUND_FX_SetParamEQ LIB "fmod.dll" ALIAS "_FSOUND_FX_SetParamEQ@16" (BYVAL fxid AS LONG, BYVAL Center AS SINGLE, BYVAL Bandwidth AS SINGLE, BYVAL Gain AS SINGLE) AS BYTE
DECLARE FUNCTION FSOUND_FX_SetWavesReverb LIB "fmod.dll" ALIAS "_FSOUND_FX_SetWavesReverb@20" (BYVAL fxid AS LONG, BYVAL InGain AS SINGLE, BYVAL ReverbMix AS SINGLE, BYVAL ReverbTime AS SINGLE, BYVAL HighFreqRTRatio AS SINGLE) AS BYTE
' ========================= */
' File Streaming functions. */
' ========================= */
'
'    Note : Use FSOUND_LOADMEMORY   flag with FSOUND_Stream_Open to stream from memory.
'           Use FSOUND_LOADRAW      flag with FSOUND_Stream_Open to treat stream as raw pcm data.
'           Use FSOUND_MPEGACCURATE flag with FSOUND_Stream_Open to open mpegs in 'accurate mode' for settime/gettime/getlengthms.
'           Use FSOUND_FREE as the 'channel' variable, to let FMOD pick a free channel for you.
'
DECLARE FUNCTION FSOUND_Stream_SetBufferSize LIB "fmod.dll" ALIAS "_FSOUND_Stream_SetBufferSize@4" (BYVAL ms AS LONG) AS BYTE
'****DECLARE FUNCTION FSOUND_Stream_Open LIB "fmod.dll" ALIAS "_FSOUND_Stream_Open@16" (BYVAL filename AS STRING, BYVAL mode AS FSOUND_MODES, BYVAL offset AS LONG, BYVAL length AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_Open LIB "fmod.dll" ALIAS "_FSOUND_Stream_Open@16" (BYVAL filename AS STRING, BYVAL mode AS LONG, BYVAL offset AS LONG, BYVAL length AS LONG) AS LONG
'****DECLARE FUNCTION FSOUND_Stream_Open2 LIB "fmod.dll" ALIAS "_FSOUND_Stream_Open@16" (BYREF DATA As Byte, ByVal mode As FSOUND_MODES, ByVal offset As Long, ByVal length As Long) As Long
'****rimosso DECLARE FUNCTION FSOUND_Stream_Open2 LIB "fmod.dll" ALIAS "_FSOUND_Stream_Open@16" (BYREF DATAi AS BYTE, BYVAL mode AS LONG, BYVAL offset AS LONG, BYVAL length AS LONG) AS LONG
 DECLARE FUNCTION FSOUND_Stream_Create LIB "fmod.dll" ALIAS "_FSOUND_Stream_Create@20" (BYVAL callback_pb AS LONG, BYVAL length AS LONG, BYVAL mode AS LONG, BYVAL samplerate AS LONG, BYVAL userdata AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_Close LIB "fmod.dll" ALIAS "_FSOUND_Stream_Close@4" (BYVAL stream AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_Play LIB "fmod.dll" ALIAS "_FSOUND_Stream_Play@8" (BYVAL channel AS LONG, BYVAL stream AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_PlayEx LIB "fmod.dll" ALIAS "_FSOUND_Stream_PlayEx@16" (BYVAL channel AS LONG, BYVAL stream AS LONG, BYVAL dsp AS LONG, BYVAL startpaused AS BYTE) AS LONG
DECLARE FUNCTION FSOUND_Stream_Stop LIB "fmod.dll" ALIAS "_FSOUND_Stream_Stop@4" (BYVAL stream AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_SetPosition LIB "fmod.dll" ALIAS "_FSOUND_Stream_SetPosition@8" (BYVAL stream AS LONG, BYVAL positition AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_GetPosition LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetPosition@4" (BYVAL stream AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_SetTime LIB "fmod.dll" ALIAS "_FSOUND_Stream_SetTime@8" (BYVAL stream AS LONG, BYVAL ms AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_GetTime LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetTime@4" (BYVAL stream AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_GetLength LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetLength@4" (BYVAL stream AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_GetLengthMs LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetLengthMs@4" (BYVAL stream AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_SetMode LIB "fmod.dll" ALIAS "_FSOUND_Stream_SetMode@8" (BYVAL stream AS LONG, BYVAL mode AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_GetMode LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetMode@4" (BYVAL stream AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_SetLoopPoints LIB "fmod.dll" ALIAS "_FSOUND_Stream_SetLoopPoints@12" (BYVAL stream AS LONG, BYVAL loopstartpcm AS LONG, BYVAL loopendpcm AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_SetLoopCount LIB "fmod.dll" ALIAS "_FSOUND_Stream_SetLoopCount@8" (BYVAL stream AS LONG, BYVAL count AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_GetOpenState LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetOpenState@4" (BYVAL stream AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_GetSample LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetSample@4" (BYVAL stream AS LONG) AS LONG
 DECLARE FUNCTION FSOUND_Stream_CreateDSP LIB "fmod.dll" ALIAS "_FSOUND_Stream_CreateDSP@16" (BYVAL stream AS LONG, BYVAL callback_pb AS LONG, BYVAL Priority AS LONG, BYVAL userdata AS LONG) AS LONG
 DECLARE FUNCTION FSOUND_Stream_SetEndCallback LIB "fmod.dll" ALIAS "_FSOUND_Stream_SetEndCallback@12" (BYVAL stream AS LONG, BYVAL callback_pb AS LONG, BYVAL userdata AS LONG) AS BYTE
 DECLARE FUNCTION FSOUND_Stream_SetSyncCallback LIB "fmod.dll" ALIAS "_FSOUND_Stream_SetSyncCallback@12" (BYVAL stream AS LONG, BYVAL callback_pb AS LONG, BYVAL userdata AS LONG) AS BYTE
'****DECLARE FUNCTION FSOUND_Stream_AddSyncPoint LIB "fmod.dll" ALIAS "_FSOUND_Stream_AddSyncPoint@12" (BYVAL stream AS LONG, BYVAL pcmoffset AS LONG, BYVAL NAME AS STRING) AS LONG
DECLARE FUNCTION FSOUND_Stream_AddSyncPoint LIB "fmod.dll" ALIAS "_FSOUND_Stream_AddSyncPoint@12" (BYVAL stream AS LONG, BYVAL pcmoffset AS LONG, BYVAL NAMEi AS STRING) AS LONG
DECLARE FUNCTION FSOUND_Stream_DeleteSyncPoint LIB "fmod.dll" ALIAS "_FSOUND_Stream_DeleteSyncPoint@4" (BYVAL point AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_GetNumSyncPoints LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetNumSyncPoints@4" (BYVAL stream AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_GetSyncPoint LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetSyncPoint@8" (BYVAL stream AS LONG, BYVAL index AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_GetSyncPointInfo LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetSyncPointInfo@8" (BYVAL point AS LONG, BYREF pcmoffset AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_SetSubStream LIB "fmod.dll" ALIAS "_FSOUND_Stream_SetSubStream@8" (BYVAL stream AS LONG, BYVAL index AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_GetNumSubStreams LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetNumSubStreams@4" (BYVAL stream AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Stream_SetSubStreamSentence LIB "fmod.dll" ALIAS "_FSOUND_Stream_SetSubStreamSentence@12" (BYVAL stream AS LONG, BYREF sentencelist AS LONG, BYVAL numitems AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_GetNumTagFields LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetNumTagFields@8" (BYVAL stream AS LONG, BYREF num AS LONG) AS BYTE
'****DECLARE FUNCTION FSOUND_Stream_GetTagField LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetTagField@24" (BYVAL stream AS LONG, BYVAL num AS LONG, BYREF tagtype AS LONG, BYREF NAME AS LONG, BYREF value AS LONG, BYREF length AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_GetTagField LIB "fmod.dll" ALIAS "_FSOUND_Stream_GetTagField@24" (BYVAL stream AS LONG, BYVAL num AS LONG, BYREF tagtype AS LONG, BYREF NAMEi AS LONG, BYREF value AS LONG, BYREF length AS LONG) AS BYTE
'****DECLARE FUNCTION FSOUND_Stream_FindTagField LIB "fmod.dll" ALIAS "_FSOUND_Stream_FindTagField@20" (BYVAL stream AS LONG, BYVAL tagtype AS LONG, BYVAL NAME AS STRING, BYREF value AS LONG, BYREF length AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_FindTagField LIB "fmod.dll" ALIAS "_FSOUND_Stream_FindTagField@20" (BYVAL stream AS LONG, BYVAL tagtype AS LONG, BYVAL NAMEi AS STRING, BYREF value AS LONG, BYREF length AS LONG) AS BYTE
'
'   Internet streaming functions
'
DECLARE FUNCTION FSOUND_Stream_Net_SetProxy LIB "fmod.dll" ALIAS "_FSOUND_Stream_Net_SetProxy@4" (BYVAL proxy AS STRING) AS BYTE
DECLARE FUNCTION FSOUND_Stream_Net_GetLastServerStatus LIB "fmod.dll" ALIAS "_FSOUND_Stream_Net_GetLastServerStatus@0" () AS LONG
DECLARE FUNCTION FSOUND_Stream_Net_SetBufferProperties LIB "fmod.dll" ALIAS "_FSOUND_Stream_Net_SetBufferProperties@12" (BYVAL buffersize AS LONG, BYVAL prebuffer_percent AS LONG, BYVAL rebuffer_percent AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_Net_GetBufferProperties LIB "fmod.dll" ALIAS "_FSOUND_Stream_Net_GetBufferProperties@12" (BYREF buffersize AS LONG, BYREF prebuffer_percent AS LONG, BYREF rebuffer_percent AS LONG) AS BYTE
 DECLARE FUNCTION FSOUND_Stream_Net_SetMetadataCallback LIB "fmod.dll" ALIAS "_FSOUND_Stream_Net_SetMetadataCallback@12" (BYVAL stream AS LONG, BYVAL callback_pb AS LONG, BYVAL userdata AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Stream_Net_GetStatus LIB "fmod.dll" ALIAS "_FSOUND_Stream_Net_GetStatus@20" (BYVAL stream AS LONG, BYREF STATUS AS LONG, BYREF bufferpercentused AS LONG, BYREF bitrate AS LONG, BYREF flags AS LONG) AS BYTE
'/* =================== */
'/* CD audio functions. */
'/* =================== */
'   Note : 0 = default cdrom.  Otherwise specify the drive letter, for example. 'D'.
DECLARE FUNCTION FSOUND_CD_Play LIB "fmod.dll" ALIAS "_FSOUND_CD_Play@8" (BYVAL drive AS BYTE, BYVAL Track AS LONG) AS BYTE
'****DECLARE FUNCTION FSOUND_CD_SetPlayMode LIB "fmod.dll" ALIAS "_FSOUND_CD_SetPlayMode@8" (BYVAL drive AS BYTE, BYVAL mode AS FSOUND_CDPLAYMODES) AS LONG
DECLARE FUNCTION FSOUND_CD_SetPlayMode LIB "fmod.dll" ALIAS "_FSOUND_CD_SetPlayMode@8" (BYVAL drive AS BYTE, BYVAL mode AS LONG) AS LONG
DECLARE FUNCTION FSOUND_CD_Stop LIB "fmod.dll" ALIAS "_FSOUND_CD_Stop@4" (BYVAL drive AS BYTE) AS BYTE
DECLARE FUNCTION FSOUND_CD_SetPaused LIB "fmod.dll" ALIAS "_FSOUND_CD_SetPaused@8" (BYVAL drive AS BYTE, BYVAL Paused AS BYTE) AS BYTE
DECLARE FUNCTION FSOUND_CD_SetVolume LIB "fmod.dll" ALIAS "_FSOUND_CD_SetVolume@8" (BYVAL drive AS BYTE, BYVAL volume AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_CD_SetTrackTime LIB "fmod.dll" ALIAS "_FSOUND_CD_SetTrackTime@8" (BYVAL drive AS BYTE, BYVAL ms AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_CD_OpenTray LIB "fmod.dll" ALIAS "_FSOUND_CD_OpenTray@8" (BYVAL drive AS BYTE, BYVAL openState AS BYTE) AS BYTE
DECLARE FUNCTION FSOUND_CD_GetPaused LIB "fmod.dll" ALIAS "_FSOUND_CD_GetPaused@4" (BYVAL drive AS BYTE) AS BYTE
DECLARE FUNCTION FSOUND_CD_GetTrack LIB "fmod.dll" ALIAS "_FSOUND_CD_GetTrack@4" (BYVAL drive AS BYTE) AS LONG
DECLARE FUNCTION FSOUND_CD_GetNumTracks LIB "fmod.dll" ALIAS "_FSOUND_CD_GetNumTracks@4" (BYVAL drive AS BYTE) AS LONG
DECLARE FUNCTION FSOUND_CD_GetVolume LIB "fmod.dll" ALIAS "_FSOUND_CD_GetVolume@4" (BYVAL drive AS BYTE) AS LONG
DECLARE FUNCTION FSOUND_CD_GetTrackLength LIB "fmod.dll" ALIAS "_FSOUND_CD_GetTrackLength@8" (BYVAL drive AS BYTE, BYVAL Track AS LONG) AS LONG
DECLARE FUNCTION FSOUND_CD_GetTrackTime LIB "fmod.dll" ALIAS "_FSOUND_CD_GetTrackTime@4" (BYVAL drive AS BYTE) AS LONG
'/* ============== */
'/* DSP functions. */
'/* ============== */
'   DSP Unit control and information functions.
'   These functions allow you access to the mixed stream that FMOD uses to play back sound on.
 DECLARE FUNCTION FSOUND_DSP_Create LIB "fmod.dll" ALIAS "_FSOUND_DSP_Create@12" (BYVAL callback_pb AS LONG, BYVAL Priority AS LONG, BYVAL param AS LONG) AS LONG
DECLARE FUNCTION FSOUND_DSP_Free LIB "fmod.dll" ALIAS "_FSOUND_DSP_Free@4" (BYVAL unit AS LONG) AS LONG
DECLARE FUNCTION FSOUND_DSP_SetPriority LIB "fmod.dll" ALIAS "_FSOUND_DSP_SetPriority@8" (BYVAL unit AS LONG, BYVAL Priority AS LONG) AS LONG
DECLARE FUNCTION FSOUND_DSP_GetPriority LIB "fmod.dll" ALIAS "_FSOUND_DSP_GetPriority@4" (BYVAL unit AS LONG) AS LONG
DECLARE FUNCTION FSOUND_DSP_SetActive LIB "fmod.dll" ALIAS "_FSOUND_DSP_SetActive@8" (BYVAL unit AS LONG, BYVAL active AS INTEGER) AS LONG
DECLARE FUNCTION FSOUND_DSP_GetActive LIB "fmod.dll" ALIAS "_FSOUND_DSP_GetActive@4" (BYVAL unit AS LONG) AS BYTE
'   Functions to get hold of FSOUND 'system DSP unit' handles
DECLARE FUNCTION FSOUND_DSP_GetClearUnit LIB "fmod.dll" ALIAS "_FSOUND_DSP_GetClearUnit@0" () AS LONG
DECLARE FUNCTION FSOUND_DSP_GetSFXUnit LIB "fmod.dll" ALIAS "_FSOUND_DSP_GetSFXUnit@0" () AS LONG
DECLARE FUNCTION FSOUND_DSP_GetMusicUnit LIB "fmod.dll" ALIAS "_FSOUND_DSP_GetMusicUnit@0" () AS LONG
DECLARE FUNCTION FSOUND_DSP_GetFFTUnit LIB "fmod.dll" ALIAS "_FSOUND_DSP_GetFFTUnit@0" () AS LONG
DECLARE FUNCTION FSOUND_DSP_GetClipAndCopyUnit LIB "fmod.dll" ALIAS "_FSOUND_DSP_GetClipAndCopyUnit@0" () AS LONG
'   Miscellaneous DSP functions
'   Note for the spectrum analysis function to work, you have to enable the FFT DSP unit with
'   the following code FSOUND_DSP_SetActive(FSOUND_DSP_GetFFTUnit(), TRUE);
'   It is off by default to save cpu usage.
DECLARE FUNCTION FSOUND_DSP_MixBuffers LIB "fmod.dll" ALIAS "_FSOUND_DSP_MixBuffers@28"_
 (BYVAL destbuffer AS LONG, BYVAL srcbuffer AS LONG, BYVAL length AS LONG, BYVAL freq AS LONG, BYVAL Vol AS LONG, BYVAL pan AS LONG, BYVAL mode AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_DSP_ClearMixBuffer LIB "fmod.dll" ALIAS "_FSOUND_DSP_ClearMixBuffer@0" () AS LONG
DECLARE FUNCTION FSOUND_DSP_GetBufferLength LIB "fmod.dll" ALIAS "_FSOUND_DSP_GetBufferLength@0" () AS LONG
DECLARE FUNCTION FSOUND_DSP_GetBufferLengthTotal LIB "fmod.dll" ALIAS "_FSOUND_DSP_GetBufferLengthTotal@0" () AS LONG
DECLARE FUNCTION FSOUND_DSP_GetSpectrum LIB "fmod.dll" ALIAS "_FSOUND_DSP_GetSpectrum@0" () AS LONG
'/* =================================================================================== */
'/* Reverb functions. (eax2/eax3 reverb)  (ONLY SUPPORTED ON WIN32 W/ FSOUND_HW3D FLAG) */
'/* =================================================================================== */
'   See top of file for definitions and information on the reverb parameters.
'The FSOUND_REVERB_PRESETS have not been included in VB yet so they cannot yet be used here...
DECLARE FUNCTION FSOUND_Reverb_SetProperties LIB "fmod.dll" ALIAS "_FSOUND_Reverb_SetProperties@4" (BYREF prop AS FSOUND_REVERB_PROPERTIES) AS BYTE
DECLARE FUNCTION FSOUND_Reverb_GetProperties LIB "fmod.dll" ALIAS "_FSOUND_Reverb_GetProperties@4" (BYREF prop AS FSOUND_REVERB_PROPERTIES) AS BYTE
DECLARE FUNCTION FSOUND_Reverb_SetChannelProperties LIB "fmod.dll" ALIAS "_FSOUND_Reverb_SetChannelProperties@8" (BYVAL channel AS LONG, BYREF prop AS FSOUND_REVERB_CHANNELPROPERTIES) AS BYTE
DECLARE FUNCTION FSOUND_Reverb_GetChannelProperties LIB "fmod.dll" ALIAS "_FSOUND_Reverb_GetChannelProperties@8" (BYVAL channel AS LONG, BYREF prop AS FSOUND_REVERB_CHANNELPROPERTIES) AS BYTE
'/* ===================================================== */
'/* Recording functions  (ONLY SUPPORTED IN WIN32, WINCE) */
'/* ===================================================== */
'    Recording initialization functions
DECLARE FUNCTION FSOUND_Record_SetDriver LIB "fmod.dll" ALIAS "_FSOUND_Record_SetDriver@4" (BYVAL outputtype AS LONG) AS BYTE
DECLARE FUNCTION FSOUND_Record_GetNumDrivers LIB "fmod.dll" ALIAS "_FSOUND_Record_GetNumDrivers@0" () AS LONG
DECLARE FUNCTION FSOUND_Record_GetDriverName LIB "fmod.dll" ALIAS "_FSOUND_Record_GetDriverName@4" (BYVAL id AS LONG) AS LONG
DECLARE FUNCTION FSOUND_Record_GetDriver LIB "fmod.dll" ALIAS "_FSOUND_Record_GetDriver@0" () AS LONG
'    Recording functionality.  Only one recording session will work at a time.
'****DECLARE FUNCTION FSOUND_Record_StartSample LIB "fmod.dll" ALIAS "_FSOUND_Record_StartSample@8" (BYVAL sample AS LONG, BYVAL loopit AS Boolean) AS BYTE
DECLARE FUNCTION FSOUND_Record_StartSample LIB "fmod.dll" ALIAS "_FSOUND_Record_StartSample@8" (BYVAL sample AS LONG, BYVAL loopit AS BYTE) AS BYTE
DECLARE FUNCTION FSOUND_Record_Stop LIB "fmod.dll" ALIAS "_FSOUND_Record_Stop@0" () AS BYTE
DECLARE FUNCTION FSOUND_Record_GetPosition LIB "fmod.dll" ALIAS "_FSOUND_Record_GetPosition@0" () AS LONG
'/* ========================================================================================== */
'/* FMUSIC API (MOD,S3M,XM,IT,MIDI PLAYBACK)                                                   */
'/* ========================================================================================== */
'   Song management / playback functions.
'****DECLARE FUNCTION FMUSIC_LoadSong LIB "fmod.dll" ALIAS "_FMUSIC_LoadSong@4" (BYVAL NAME AS STRING) AS LONG
DECLARE FUNCTION FMUSIC_LoadSong LIB "fmod.dll" ALIAS "_FMUSIC_LoadSong@4" (BYVAL NAMEi AS STRING) AS LONG
'****DECLARE FUNCTION FMUSIC_LoadSongEx LIB "fmod.dll" ALIAS "_FMUSIC_LoadSongEx@24" (BYVAL NAME AS STRING, BYVAL offset AS LONG, BYVAL length AS LONG, BYVAL mode AS FSOUND_MODES, BYREF sentencelist AS LONG, BYVAL numitems AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_LoadSongEx LIB "fmod.dll" ALIAS "_FMUSIC_LoadSongEx@24" (BYVAL NAMEi AS STRING, BYVAL offset AS LONG, BYVAL length AS LONG, BYVAL mode AS LONG, BYREF sentencelist AS LONG, BYVAL numitems AS LONG) AS LONG
'**** rimosso DECLARE FUNCTION FMUSIC_LoadSongEx2 LIB "fmod.dll" ALIAS "_FMUSIC_LoadSongEx@24" (BYREF DATA As Byte, ByVal offset As Long, ByVal length As Long, ByVal mode As FSOUND_MODES, ByRef sentencelist As Long, ByVal numitems As Long) As Long
DECLARE FUNCTION FMUSIC_GetOpenState LIB "fmod.dll" ALIAS "_FMUSIC_GetOpenState@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_FreeSong LIB "fmod.dll" ALIAS "_FMUSIC_FreeSong@4" (BYVAL module AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_PlaySong LIB "fmod.dll" ALIAS "_FMUSIC_PlaySong@4" (BYVAL module AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_StopSong LIB "fmod.dll" ALIAS "_FMUSIC_StopSong@4" (BYVAL module AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_StopAllSongs LIB "fmod.dll" ALIAS "_FMUSIC_StopAllSongs@0" () AS LONG
DECLARE FUNCTION FMUSIC_SetZxxCallback LIB "fmod.dll" ALIAS "_FMUSIC_SetZxxCallback@8" (BYVAL module AS LONG, BYVAL callback_pb AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_SetRowCallback LIB "fmod.dll" ALIAS "_FMUSIC_SetRowCallback@12" (BYVAL module AS LONG, BYVAL callback_pb AS LONG, BYVAL rowstep AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_SetOrderCallback LIB "fmod.dll" ALIAS "_FMUSIC_SetOrderCallback@12" (BYVAL module AS LONG, BYVAL callback_pb AS LONG, BYVAL rowstep AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_SetInstCallback LIB "fmod.dll" ALIAS "_FMUSIC_SetInstCallback@12" (BYVAL module AS LONG, BYVAL callback_pb AS LONG, BYVAL instrument AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_SetSample LIB "fmod.dll" ALIAS "_FMUSIC_SetSample@12" (BYVAL module AS LONG, BYVAL sampno AS LONG, BYVAL sptr AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_SetUserData LIB "fmod.dll" ALIAS "_FMUSIC_SetUserData@8" (BYVAL module AS LONG, BYVAL userdata AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_OptimizeChannels LIB "fmod.dll" ALIAS "_FMUSIC_OptimizeChannels@12" (BYVAL module AS LONG, BYVAL maxchannels AS LONG, BYVAL minvolume AS LONG) AS BYTE
'   Runtime song functions
DECLARE FUNCTION FMUSIC_SetReverb LIB "fmod.dll" ALIAS "_FMUSIC_SetReverb@4" (BYVAL Reverb AS BYTE) AS BYTE
DECLARE FUNCTION FMUSIC_SetLooping LIB "fmod.dll" ALIAS "_FMUSIC_SetLooping@8" (BYVAL module AS LONG, BYVAL looping AS BYTE) AS BYTE
DECLARE FUNCTION FMUSIC_SetOrder LIB "fmod.dll" ALIAS "_FMUSIC_SetOrder@8" (BYVAL module AS LONG, BYVAL order AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_SetPaused LIB "fmod.dll" ALIAS "_FMUSIC_SetPaused@8" (BYVAL module AS LONG, BYVAL Pause AS BYTE) AS BYTE
DECLARE FUNCTION FMUSIC_SetMasterVolume LIB "fmod.dll" ALIAS "_FMUSIC_SetMasterVolume@8" (BYVAL module AS LONG, BYVAL volume AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_SetMasterSpeed LIB "fmod.dll" ALIAS "_FMUSIC_SetMasterSpeed@8" (BYVAL module AS LONG, BYVAL speed AS SINGLE) AS BYTE
DECLARE FUNCTION FMUSIC_SetPanSeperation LIB "fmod.dll" ALIAS "_FMUSIC_SetPanSeperation@8" (BYVAL module AS LONG, BYVAL pansep AS SINGLE) AS BYTE
'   Static song information functions
DECLARE FUNCTION FMUSIC_GetName LIB "fmod.dll" ALIAS "_FMUSIC_GetName@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetType LIB "fmod.dll" ALIAS "_FMUSIC_GetType@4" (BYVAL module AS LONG) AS LONG'FMUSIC_TYPES
DECLARE FUNCTION FMUSIC_GetNumOrders LIB "fmod.dll" ALIAS "_FMUSIC_GetNumOrders@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetNumPatterns LIB "fmod.dll" ALIAS "_FMUSIC_GetNumPatterns@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetNumInstruments LIB "fmod.dll" ALIAS "_FMUSIC_GetNumInstruments@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetNumSamples LIB "fmod.dll" ALIAS "_FMUSIC_GetNumSamples@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetNumChannels LIB "fmod.dll" ALIAS "_FMUSIC_GetNumChannels@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetSample LIB "fmod.dll" ALIAS "_FMUSIC_GetSample@8" (BYVAL module AS LONG, BYVAL sampno AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetPatternLength LIB "fmod.dll" ALIAS "_FMUSIC_GetPatternLength@8" (BYVAL module AS LONG, BYVAL orderno AS LONG) AS LONG
'   Runtime song information
DECLARE FUNCTION FMUSIC_IsFinished LIB "fmod.dll" ALIAS "_FMUSIC_IsFinished@4" (BYVAL module AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_IsPlaying LIB "fmod.dll" ALIAS "_FMUSIC_IsPlaying@4" (BYVAL module AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_GetMasterVolume LIB "fmod.dll" ALIAS "_FMUSIC_GetMasterVolume@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetGlobalVolume LIB "fmod.dll" ALIAS "_FMUSIC_GetGlobalVolume@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetOrder LIB "fmod.dll" ALIAS "_FMUSIC_GetOrder@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetPattern LIB "fmod.dll" ALIAS "_FMUSIC_GetPattern@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetSpeed LIB "fmod.dll" ALIAS "_FMUSIC_GetSpeed@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetBPM LIB "fmod.dll" ALIAS "_FMUSIC_GetBPM@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetRow LIB "fmod.dll" ALIAS "_FMUSIC_GetRow@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetPaused LIB "fmod.dll" ALIAS "_FMUSIC_GetPaused@4" (BYVAL module AS LONG) AS BYTE
DECLARE FUNCTION FMUSIC_GetTime LIB "fmod.dll" ALIAS "_FMUSIC_GetTime@4" (BYVAL module AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetRealChannel LIB "fmod.dll" ALIAS "_FMUSIC_GetRealChannel@8" (BYVAL module AS LONG, BYVAL modchannel AS LONG) AS LONG
DECLARE FUNCTION FMUSIC_GetUserData LIB "fmod.dll" ALIAS "_FMUSIC_GetUserData@4" (BYVAL module AS LONG) AS LONG
'************
'* Windows Declarations (Added by Adion)
'************
'Required for GetStringFromPointer
'****rimosso DECLARE FUNCTION ConvCStringToVBString LIB "kernel32" ALIAS "lstrcpyA" (BYVAL lpsz AS STRING, BYVAL pt AS LONG) AS LONG ' Notice the As Long return value replacing the As String given by the API Viewer.
'Required for the FFT/Spectral functions
'****rimosso DECLARE SUB CopyMemory LIB "kernel32" ALIAS "RtlMoveMemory" (Destination AS ANY, Source AS ANY, BYVAL length AS LONG)
'************
'* FUNCTIONS (Added by Adion)
'************
'Usage: myerrorstring = FSOUND_GetErrorString(FSOUND_GetError)
FUNCTION FSOUND_GetErrorString(BYVAL errorcode AS LONG) AS STRING
SELECT CASE errorcode
CASE %FMOD_ERR_NONE:             FSOUND_GetErrorString = "No errors"
CASE %FMOD_ERR_BUSY:             FSOUND_GetErrorString = "Cannot call this command after FSOUND_Init.  Call FSOUND_Close first."
CASE %FMOD_ERR_UNINITIALIZED:    FSOUND_GetErrorString = "This command failed because FSOUND_Init was not called"
CASE %FMOD_ERR_PLAY:             FSOUND_GetErrorString = "Playing the sound failed."
CASE %FMOD_ERR_INIT:             FSOUND_GetErrorString = "Error initializing output device."
CASE %FMOD_ERR_ALLOCATED:        FSOUND_GetErrorString = "The output device is already in use and cannot be reused."
CASE %FMOD_ERR_OUTPUT_FORMAT:    FSOUND_GetErrorString = "Soundcard does not support the features needed for this soundsystem (16bit stereo output)"
CASE %FMOD_ERR_COOPERATIVELEVEL: FSOUND_GetErrorString = "Error setting cooperative level for hardware."
CASE %FMOD_ERR_CREATEBUFFER:     FSOUND_GetErrorString = "Error creating hardware sound buffer."
CASE %FMOD_ERR_FILE_NOTFOUND:    FSOUND_GetErrorString = "File not found"
CASE %FMOD_ERR_FILE_FORMAT:      FSOUND_GetErrorString = "Unknown file format"
CASE %FMOD_ERR_FILE_BAD:         FSOUND_GetErrorString = "Error loading file"
CASE %FMOD_ERR_MEMORY:           FSOUND_GetErrorString = "Not enough memory "
CASE %FMOD_ERR_VERSION:          FSOUND_GetErrorString = "The version number of this file format is not supported"
CASE %FMOD_ERR_INVALID_PARAM:    FSOUND_GetErrorString = "An invalid parameter was passed to this function"
CASE %FMOD_ERR_NO_EAX:           FSOUND_GetErrorString = "Tried to use an EAX command on a non EAX enabled channel or output."
CASE %FMOD_ERR_CHANNEL_ALLOC:    FSOUND_GetErrorString = "Failed to allocate a new channel"
CASE %FMOD_ERR_RECORD:           FSOUND_GetErrorString = "Recording is not supported on this machine"
CASE %FMOD_ERR_MEDIAPLAYER:      FSOUND_GetErrorString = "Required Mediaplayer codec is not installed"
CASE %FMOD_ERR_CDDEVICE:         FSOUND_GetErrorString = "An error occured trying to open the specified CD device"
CASE ELSE:                       FSOUND_GetErrorString = "Unknown error"
END SELECT
END FUNCTION
'Thanks to KarLKoX for the following function
'Example: MyDriverName = GetStringFromPointer(FSOUND_GetDriverName(count))
FUNCTION GetStringFromPointer(BYVAL lpString AS LONG) AS STRING
DIM NullCharPos AS LONG
DIM szBuffer AS STRING
szBuffer = STRING$(255, 0)
'****rimosso ConvCStringToVBString szBuffer, lpString
' Look for the null char ending the C string
NullCharPos = INSTR(szBuffer, CHR$(0))
GetStringFromPointer = LEFT$(szBuffer, NullCharPos - 1)
END FUNCTION

$IF 0
'These functions are added by Adion
FUNCTION GetSingleFromPointer(BYVAL lpSingle AS LONG) AS SINGLE
'A Single is 4 bytes, so we copy 4 bytes
CopyMemory GetSingleFromPointer, BYVAL lpSingle, 4
END FUNCTION
$ENDIF

'Warning: You should set the fft dsp to active before retreiving the spectrum
'Also make sure the array you pass is dimensioned and ready to use
'FSOUND_DSP_SetActive FSOUND_DSP_GetFFTUnit, 1
FUNCTION GetSpectrum(BYREF Spectrum() AS SINGLE) AS LONG
DIM nrOfVals AS LONG, lpSpectrum AS LONG
DIM a AS LONG
IF UBOUND(Spectrum) > 511 THEN nrOfVals = 512 ELSE nrOfVals = UBOUND(Spectrum) + 1
lpSpectrum = FSOUND_DSP_GetSpectrum
CopyMemory Spectrum(0), BYVAL lpSpectrum, nrOfVals * 4
END FUNCTION
